#pragma once

#define _CRT_SECURE_NO_WARNINGS

#include <math.h>
#include "opencv2/opencv.hpp"

using namespace cv;

// Straight line ax+by+c=0
double distancePointLine(double x, double y, double a, double b, double c);

// Straight line y=ax+b
double distancePointLine(double x, double y, double a, double b);

class CalibrationGeo
{
public:
  CalibrationGeo();
  ~CalibrationGeo();
  void Calibrate(Point2f* pTPtImage, Point2f* pTPtWorld, int nCount);
  void InitLUT(int nSzX, int nSzY);
  void Transform(const Mat imgSrc, Mat imgDst);

protected:
  Mat m_mx1DPerspective;//Matx33f 
  //float m_f32MxPerspective[9];//Matx33f 
  Mat m_mx2DLUT;
  int m_n32LUTSzX, m_n32LUTSzY;
};

