#ifndef QIMAGESCROLLAREA_H
#define QIMAGESCROLLAREA_H

#include <QScrollArea>
#include <QPrinter>
#include "QOpenCV.h"

QT_BEGIN_NAMESPACE
class QLabel;
class QScrollArea;
class QScrollBar;
class QMenu;
QT_END_NAMESPACE

  //! [0]
class QImageScrollArea : public QScrollArea
{
  Q_OBJECT

public:
  QImageScrollArea();

  QMenu* getMenu()
  {
    return m_pMenu;
  }

  void update();

public slots:
  void warp();
  void shading();

private slots:
  void newSlot();
  void openSlot();
  void saveSlot();
  void print();
  void zoomIn();
  void zoomOut();
  void normalSize();
  void fitToWindow();

  void slotSliderH_ValueChanged ( int min);
  void slotSliderV_ValueChanged ( int min);
  
signals:
  void signalMousePress(int nX, int nY);

public:
  void createActions();
  QMenu* createMenus();
  void updateActions();
  void LabelFromImage();
  void scaleImage(double factor);
  void adjustScrollBar(QScrollBar *scrollBar, double factor);

  void initLUT();
  
  // QWidget virtual functions (events)
  virtual void dropEvent (QDropEvent* pEvent);
  virtual void mousePressEvent(QMouseEvent* pEvent);
  virtual void mouseReleaseEvent(QMouseEvent* pEvent);
  virtual void wheelEvent(QWheelEvent* pEvent);
  virtual void keyPressEvent(QKeyEvent* pEvent);
  
  QCVImage* getQCVImage(){return &m_QCVImage;}

public:
  QCVImage  m_QCVImage;

  QAction*  m_printAct;
  QAction*  m_zoomInAct;
  QAction*  m_zoomOutAct;
  QAction*  m_normalSizeAct;
  QAction*  m_fitToWindowAct;
  QMenu*    m_pMenu;

#ifndef QT_NO_PRINTER
  QPrinter m_Printer;
#endif
};
//! [0]

#endif
