#pragma once

#include <QtGui>
#include <QtWidgets>

#define _CRT_SECURE_NO_WARNINGS

#include "opencv2/opencv.hpp"
//#include "opencv2/core/core.hpp"
//#include "opencv2/highgui/highgui.hpp"

#define MAX_IMG_CNT 10
class CVProcessing
{
public:
  CVProcessing();
  bool addImg(cv::Mat& newImg, bool bSrc = true);
  cv::Mat& getImg(bool bSrc = true, int nIdx = -1, bool bLastBased = false);
  
  void addROI(cv::Point* ptROI, int nPtCnt);
  void addROI(cv::Rect rcROI);
  cv::Point* getROI(int nID);

protected:
  cv::Mat   m_MatSrc[MAX_IMG_CNT];
  cv::Mat   m_MatDst[MAX_IMG_CNT];
  int       m_nSrcCnt;
  int       m_nDstCnt;
  
  cv::Point m_ptROISrc[4], m_ptROIDst[4];
};

#define ROI_HANDLE_UPL  0
#define ROI_HANDLE_DNL  1
#define ROI_HANDLE_DNR  2
#define ROI_HANDLE_UPR  3
#define ROI_HANDLE_IN   4
#define ROI_HANDLE_OUT  5

class QCVImage : public QLabel, public CVProcessing
{
  Q_OBJECT
public:
  QCVImage();
  QCVImage(QString& strPath);
  ~QCVImage();

  /*
  QPoint& GetScroll();
  */
  bool isEmpty();
  bool load(QString& strPath);
  bool save(QString& strPath);
  void update();
  void zoom(double f64Zoom); 
  void mouseMouve(int nX, int nY, int nButton);

  void Warp();
  void ShadingCorrection(int nMeshSize = 100);

protected:
  void paintEvent(QPaintEvent* pQPaintEvent);
  virtual void mouseMoveEvent (QMouseEvent* pEvent);

protected:
  QPixmap   m_QPixmap;
  //QPoint    m_ptScroll;
  double    m_f64Zoom;

  cv::Point m_ptHandleStart;
  int       m_nHandleMove, m_nHandleStart;

};
