#include "QParametersDialog.h"
#include "QParameter.h"

QParametersDialog::QParametersDialog(QParameter* pQParameter)
{
  m_pLayout = NULL;

  Initialize(pQParameter);
}

void QParametersDialog::Initialize(QParameter* pQParameter)
{
  deleteWidgets();

  m_pLayout = new QVBoxLayout(this);
  //pQParameter
  //QBoxLayout* pLayout = addInteger(pQParameter);
  
  //m_pLayout->addWidget(pLayout);

  setLayout(m_pLayout);
}

void QParametersDialog::deleteWidgets()
{
  if(m_pLayout)
  {
    QLayoutItem* pVLI;
    while((pVLI = m_pLayout->takeAt(0)) != 0)// = removeItem
    {
      QLayout* pHL = pVLI->layout();
      if(pHL)
      {
        QLayoutItem* pHLI;
        while((pHLI = pHL->takeAt(0)) != 0)
        {
          if(pHLI->widget())
            delete pHLI->widget();
          delete pHLI;
        }
      }
      delete pVLI;
    }

    //Q_ASSERT(m_pLayout == layout());
    //m_pLayout->removeItem(m_pLayoutProperties);

    delete m_pLayout;
    m_pLayout = NULL;

    update();    
  }
}
QBoxLayout* QParametersDialog::addInteger(QParameter* pQParameter)
{
  QString strLabel(QTCHAR(pQParameter->GetName()));
  QLabel* label = new QLabel(strLabel);

  QSpinBox *spinBox = new QSpinBox;
  QSlider *slider = new QSlider(Qt::Horizontal);
  
  int minimum, maximum;
  pQParameter->GetRange(minimum, maximum);
  spinBox->setRange(minimum, maximum);
  slider->setRange(minimum, maximum);
  spinBox->setValue(pQParameter->GetDefault());

  connect(spinBox, SIGNAL(valueChanged(int)), slider, SLOT(setValue(int)));
  connect(slider, SIGNAL(valueChanged(int)), spinBox, SLOT(setValue(int)));
  connect(slider, SIGNAL(valueChanged(int)), pQParameter, SLOT(setValue(int)));

  QHBoxLayout *pHLayout = new QHBoxLayout;
  pHLayout->addWidget(label);
  pHLayout->addWidget(spinBox);
  pHLayout->addWidget(slider);

  return pHLayout;
}